from typing import Any

from pydantic import BaseModel
from selenium import webdriver
from selenium.webdriver.remote.webdriver import WebDriver

from ddt_framework.service import service, Service
from ddt_framework.step import Step
from ddt_framework.utils import log
from ddt_framework.web import web, Web


class TestCase(BaseModel):
    name: str = None
    # setup
    given: list[dict] = []
    # 测试步骤
    when: list[dict] = []
    # 断言
    then: list[dict] = []

    def __init__(self, **data: Any) -> None:
        super().__init__(**data)

    def run(self):
        log.info('run testcase')
        log.info(self)

        log.info(self.given)
        for step in self.given:
            self.run_step(step)

        log.info('run testcase when')
        log.info(self.when)
        for step in self.when:
            self.run_step(step)

        log.info(self.then)
        for step in self.then:
            self.run_step(step)

    def run_step(self, step: dict):
        global web, service
        log.info('run step')
        log.info(step)

        if web is None:
            web = Web()
        web.run_step(step)

        if service is None:
            servic = Service()

        service.run_step(step)
