import pytest as pytest

from ddt_framework.utils import log
from src.ddt_framework.yaml_item import YamlItem


class YamlFile(pytest.File):
    def collect(self):
        # pytest会调用collect，获得每个文件的测试用例
        # We need a yaml parser, e.g. PyYAML.
        import yaml

        # 读取文件的结构 dict
        raw = yaml.safe_load(self.path.open())
        if raw:
            for name, spec in sorted(raw.items()):
                # 对每个kv结构
                log.debug(name)
                log.debug(spec)
                yield YamlItem.from_parent(self, name=name, spec=spec)
